> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Start OAuth Authorization

> Start OAuth Authorization using the Stytch React SDK

Initiates a request for authorization of a Connected App to access a User's account. Call this endpoint using the query parameters from an OAuth Authorization request. This endpoint validates various fields (`scope`, `client_id`, `redirect_uri`, `prompt`, etc.) are correct and returns relevant information for rendering an OAuth Consent Screen.

## Parameters

<ParamField body="client_id" type="string" required>
  The ID of the Connected App client.
</ParamField>

<ParamField body="redirect_uri" type="string" required>
  The callback URI used to redirect the user after authentication. This is the same URI provided at the start of the OAuth flow. This field is required when using the authorization\_code grant.
</ParamField>

<ParamField body="response_type" type="string" required>
  The OAuth 2.0 response type. For authorization code flows this value is code.
</ParamField>

<ParamField body="scopes" type="array[strings]" required>
  An array of scopes requested by the client.
</ParamField>

<ParamField body="prompt" type="string">
  Space separated list that specifies how the Authorization Server should prompt the user for reauthentication and consent. Only consent is supported today.
</ParamField>

## Response

<ResponseField name="user_id" type="string">
  The unique ID of the affected User.
</ResponseField>

<ResponseField name="user" type="object">
  The user object affected by this API call. See the [User object](/docs/api-reference/consumer/api/users/user-object) for complete response field details.

  <Expandable title="properties">
    <ResponseField name="created_at" type="string">
      The timestamp of the User's creation. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
    </ResponseField>

    <ResponseField name="crypto_wallets" type="array[objects]">
      An array contains a list of all crypto wallets for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="crypto_wallet_id" type="string">
          The unique ID for a crypto wallet
        </ResponseField>

        <ResponseField name="crypto_wallet_address" type="string">
          The actual blockchain address of the User's crypto wallet.
        </ResponseField>

        <ResponseField name="crypto_wallet_type" type="string">
          The blockchain that the User's crypto wallet operates on, e.g. Ethereum, Solana, etc.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="emails" type="array[objects]">
      An array of email objects for the User.

      <Expandable title="properties">
        <ResponseField name="email_id" type="string">
          The unique ID of a specific email address.
        </ResponseField>

        <ResponseField name="email" type="string">
          The email address.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="name" type="object">
      The name of the User. Each field in the name object is optional.

      <Expandable title="properties">
        <ResponseField name="first_name" type="string">
          The first name of the user.
        </ResponseField>

        <ResponseField name="middle_name" type="string">
          The middle name(s) of the user.
        </ResponseField>

        <ResponseField name="last_name" type="string">
          The last name of the user.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="trusted_metadata" type="object">
      The trusted\_metadata field contains an arbitrary JSON object of application-specific data. See the [Metadata](/docs/api-reference/consumer/api/resources/metadata) reference for complete field behavior details.
    </ResponseField>

    <ResponseField name="untrusted_metadata" type="object">
      The untrusted\_metadata field contains an arbitrary JSON object of application-specific data. Untrusted metadata can be edited by end users directly via the SDK, and **cannot be used to store critical information.** See the [Metadata](/docs/api-reference/consumer/api/resources/metadata) reference for complete field behavior details.
    </ResponseField>

    <ResponseField name="phone_numbers" type="array[objects]">
      An array of phone number objects linked to the User.

      <Expandable title="properties">
        <ResponseField name="phone_id" type="string">
          The unique ID for the phone number.
        </ResponseField>

        <ResponseField name="phone_number" type="string">
          The phone number.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="providers" type="array[objects]">
      An array of OAuth provider objects linked to the User.

      <Expandable title="properties">
        <ResponseField name="oauth_user_registration_id" type="string">
          The unique ID for an OAuth registration.
        </ResponseField>

        <ResponseField name="provider_subject" type="string">
          The unique identifier for the User within a given OAuth provider. Also commonly called the "sub" or "Subject field" in OAuth protocols.
        </ResponseField>

        <ResponseField name="provider_type" type="string">
          Denotes the OAuth identity provider that the user has authenticated with, e.g. Google, Facebook, GitHub etc.
        </ResponseField>

        <ResponseField name="profile_picture_url" type="string">
          If available, the profile\_picture\_url is a url of the User's profile picture set in OAuth identity the provider that the User has authenticated with, e.g. Facebook profile picture.
        </ResponseField>

        <ResponseField name="locale" type="string">
          If available, the locale is the User's locale set in the OAuth identity provider that the user has authenticated with.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="password" type="object">
      The password object is returned for users with a password.

      <Expandable title="properties">
        <ResponseField name="password_id" type="string">
          The unique ID of a specific password
        </ResponseField>

        <ResponseField name="requires_reset" type="boolean">
          Indicates whether this password requires a password reset
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="status" type="string">
      The status of the User. The possible values are `pending` and `active`.
    </ResponseField>

    <ResponseField name="totps" type="array[objects]">
      An array containing a list of all TOTP instances for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="totp_id" type="string">
          The unique ID for a TOTP instance.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="user_id" type="string">
      The unique ID of the affected User.
    </ResponseField>

    <ResponseField name="webauthn_registrations" type="array[objects]">
      An array that contains a list of all Passkey or WebAuthn registrations for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="webauthn_registration_id" type="string">
          The unique ID for the Passkey or WebAuthn registration.
        </ResponseField>

        <ResponseField name="domain" type="string">
          The domain on which Passkey or WebAuthn registration was started. This will be the domain of your app.
        </ResponseField>

        <ResponseField name="user_agent" type="string">
          The user agent of the User.
        </ResponseField>

        <ResponseField name="authenticator_type" type="string">
          The authenticator\_type string displays the requested authenticator type of the Passkey or WebAuthn device. The two valid types are "platform" and "cross-platform". If no value is present, the Passkey or WebAuthn device was created without an authenticator type preference.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>

        <ResponseField name="name" type="string">
          The name of the Passkey or WebAuthn registration.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="biometric_registrations" type="array[objects]">
      An array that contains a list of all biometric registrations for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="biometric_registration_id" type="string">
          The unique ID for a biometric registration.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="roles" type="array[strings]">
      Roles assigned to this User. See the [RBAC guide](/docs/consumer-auth/authorization/assigning-roles-to-users) for more information about role assignment.
    </ResponseField>
  </Expandable>
</ResponseField>

<ResponseField name="connected_app" type="object">
  The Connected App affected by this operation. Only a subset of fields safe for public viewing are returned.

  <Expandable title="properties">
    <ResponseField name="client_id" type="string">
      The ID of the Connected App client.
    </ResponseField>

    <ResponseField name="client_name" type="string">
      A human-readable name for the client.
    </ResponseField>

    <ResponseField name="client_description" type="string">
      A human-readable description for the client.
    </ResponseField>

    <ResponseField name="client_type" type="string">
      The type of Connected App. Supported values are first\_party, first\_party\_public, third\_party, and third\_party\_public.
    </ResponseField>

    <ResponseField name="client_logo_url" type="string">
      The logo URL of the Connected App, if any.
    </ResponseField>
  </Expandable>
</ResponseField>

<ResponseField name="consent_required" type="boolean">
  Whether the user must provide explicit consent for the authorization request.
</ResponseField>

<ResponseField name="scope_results" type="array[object]">
  Details about each requested scope.

  <Expandable title="properties">
    <ResponseField name="scope" type="string">
      The name of the scope.
    </ResponseField>

    <ResponseField name="description" type="string">
      A human-readable description of the scope, taken from the RBAC Policy.
    </ResponseField>

    <ResponseField name="is_grantable" type="boolean">
      Indicates whether the scope can be granted. Users can only grant scopes if they have the required permissions.
    </ResponseField>
  </Expandable>
</ResponseField>

<ResponseField name="request_id" type="string">
  Globally unique UUID that is returned with every API call. This value is important to log for debugging purposes; we
  may ask for this value to help identify a specific API call when helping you debug an issue.
</ResponseField>

<ResponseField name="status_code" type="number">
  The HTTP status code of the response. Stytch follows standard HTTP response status code patterns, e.g. 2XX values
  equate to success, 3XX values are redirects, 4XX are client errors, and 5XX are server errors.
</ResponseField>

<Panel>
  <RequestExample>
    ```jsx theme={null}
    import { useState } from 'react';
    import { useStytch } from '@stytch/react';

    export const OAuthAuthorizeStart = () => {
      const stytch = useStytch();
      const [loading, setLoading] = useState(false);
      const [result] = useState(null);

      const startOAuthAuthorization = async () => {
        setLoading(true);
        try {
          await stytch.idp.oauthAuthorizeStart({
            client_id: '${exampleConnectedAppClientID}',
            redirect_uri: 'https://example.com/callback',
            response_type: 'code',
            scopes: ['openid', 'profile', 'email'],
            prompt: 'consent',
          });
        } catch (error) {
          console.error('Error starting OAuth authorization:', error);
        } finally {
          setLoading(false);
        }
      };

      return (
        <div>
          <button onClick={startOAuthAuthorization} disabled={loading}>
            {loading ? 'Starting Authorization...' : 'Start OAuth Authorization'}
          </button>
          {result && (
            <div>
              <h3>Authorization Result:</h3>
              <pre>{JSON.stringify(result, null, 2)}</pre>
            </div>
          )}
        </div>
      );
    };
    ```
  </RequestExample>

  <ResponseExample>
    ```json 200 theme={null}
    {
        "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
        "user_id": "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
        "user": {
          "user_id": "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
          "email_address": "sandbox@stytch.com",
          "status": "active",
          "name": "Sandbox User",
          "created_at": "2023-06-01T12:00:00Z",
          "updated_at": "2023-06-01T12:00:00Z"
        },
        "connected_app": {
          "client_id": "example-connected-app-client-id",
          "client_name": "Example Connected App",
          "client_description": "An example connected app for testing",
          "client_logo_url": "https://example.com/app-logo.png",
          "client_website_url": "https://example.com",
          "client_terms_of_service_url": "https://example.com/terms",
          "client_privacy_policy_url": "https://example.com/privacy"
        },
        "consent_required": true,
        "connected_app_scope_results": [
          {
            "scope": "openid",
            "description": "Request basic profile information",
            "is_grantable": true
          },
          {
            "scope": "profile",
            "description": "Request basic profile information",
            "is_grantable": true
          },
          {
            "scope": "email",
            "description": "Request email address",
            "is_grantable": true
          },
          {
            "scope": "read:data",
            "description": "Read user data",
            "is_grantable": true
          }
        ]
      }
    ```
  </ResponseExample>
</Panel>
